use super::*;

/// Visitor used in [`Mentionable::points_typed`].
pub trait PointsVisitor<'a, Ctx: Context<'a>> {
    /// Visit a [Point].
    fn visit<A: Mentionable<'a, Ctx>>(&mut self, point: &Point<'a, Ctx, A>);
}

impl<'a, Ctx: Context<'a>> PointsVisitor<'a, Ctx> for Vec<u8> {
    /// The only natural implementation, as used in [`Mentionable::topology`].
    fn visit<A: Mentionable<'a, Ctx>>(&mut self, point: &Point<'a, Ctx, A>) {
        self.extend(point.point)
    }
}
